#include <string>
using namespace std;

typedef string KeyType;

class KeyedItem
{
public:
   KeyedItem() {};
   KeyedItem(const KeyType& keyValue) 
      :searchKey(keyValue) { }
   KeyType getKey() const
   { 
      return searchKey;
   }  // end getKey
private:
   KeyType searchKey;
};  // end class

class Person : public KeyedItem 
{
public:
   Person() {}
   Person(const string& name, 
          const string& id,
          const string& phone):
      KeyedItem(name), idNum(id), 
      phoneNumber(phone) { }
private:
   // Key item is the person's name
   string idNum;
   string phoneNumber;
   //... and other data about the person
};  // end class
